/*******************************************************************************/
/*					             PROPOX                                        */
/*                           www.propox.com                                    */
/*                                                                             */
/* Program demonsturjacy dzialanie wyswietlaczy 7seg - zegar z mozliwoscia     */
/* przestrajania godziny.                                                      */
/* This program show how to use 7-seg display with atmega familly              */
/* microcontroller - clock with hour seting.                                   */
/*******************************************************************************/
// wewnetrzny zegar 1MHz (internal oscillator 1MHz)
// 7-seg
// PC0 - AN0
// PC1 - AN1
// PC2 - AN2
// PC3 - AN3
// PD0 - A
// PD1 - B
// PD2 - C
// PD3 - D
// PD4 - E
// PD5 - F
// PD6 - G
// PD7 - DP
// Switches
// PB0 - SW0 
// PB1 - SW1
// PB6 - SW6
// PB7 - SW7
#include <avr/io.h>               
#include <avr/interrupt.h>        // funkcje sei(), cli()
#include <avr/signal.h>           // definicje SIGNAL, INTERRUPT

#include "conf.h" 

#define F_CPU 1000000UL  // 1 MHz
#include <util/delay.h>


uint8_t init = 1;   

uint8_t kropka;
uint8_t delay;

uint8_t sec = 0;

//godzina
uint8_t godz_h = 1;
uint8_t godz_l = 2;
uint8_t min_h  = 0;
uint8_t min_l  = 0;


//funkcja obslogi wyswietlacza
void display_7seg(uint8_t init,char znak_1,char znak_2,char znak_3,char znak_4)
{
uint8_t wys_1;
uint8_t wys_2;
uint8_t wys_3;
uint8_t wys_4;

	switch(znak_1)
	 {
	 	case 0 : wys_1=192;
				 break;
	 	case 1 : wys_1=249;  
	             break;
	 	case 2 : wys_1=164;  
	             break;
	 	case 3 : wys_1=176;  
	             break;
	 	case 4 : wys_1=153;  
	             break;
	 	case 5 : wys_1=146;  
	             break;
	 	case 6 : wys_1=130;  
	             break;
	 	case 7 : wys_1=248;  
	             break;
	 	case 8 : wys_1=128;  
	             break;
	 	case 9 : wys_1=144;  
	             break;
     }
	switch(znak_2)
	 {
	 	case 0 : wys_2=192;
				 break;
	 	case 1 : wys_2=249;  
	             break;
	 	case 2 : wys_2=164;  
	             break;
	 	case 3 : wys_2=176;  
	             break;
	 	case 4 : wys_2=153;  
	             break;
	 	case 5 : wys_2=146;  
	             break;
	 	case 6 : wys_2=130;  
	             break;
	 	case 7 : wys_2=248;  
	             break;
	 	case 8 : wys_2=128;  
	             break;
	 	case 9 : wys_2=144;  
	             break;
     }
	switch(znak_3)
	 {
	 	case 0 : wys_3=192;
				 break;
	 	case 1 : wys_3=249;  
	             break;
	 	case 2 : wys_3=164;  
	             break;
	 	case 3 : wys_3=176;  
	             break;
	 	case 4 : wys_3=153;  
	             break;
	 	case 5 : wys_3=146;  
	             break;
	 	case 6 : wys_3=130;  
	             break;
	 	case 7 : wys_3=248;  
	             break;
	 	case 8 : wys_3=128;  
	             break;
	 	case 9 : wys_3=144;  
	             break;
     }
	switch(znak_4)
	 {
	 	case 0 : wys_4=192;
				 break;
	 	case 1 : wys_4=249;  
	             break;
	 	case 2 : wys_4=164;  
	             break;
	 	case 3 : wys_4=176;  
	             break;
	 	case 4 : wys_4=153;  
	             break;
	 	case 5 : wys_4=146;  
	             break;
	 	case 6 : wys_4=130;  
	             break;
	 	case 7 : wys_4=248;  
	             break;
	 	case 8 : wys_4=128;  
	             break;
	 	case 9 : wys_4=144;  
	             break;
     }


	//przemiatanie wyswietlaczy 7-seg
	switch(init)
     {
        case 1 : Display ^= 1<<Disp3|0<<Disp2|0<<Disp1|1<<Disp0;  
				 Segment  = wys_1; 
                 break;
        case 2 : Display ^= 1<<Disp3|1<<Disp2|0<<Disp1|0<<Disp0;  
				 if(kropka==0)   Segment = wys_2 & 0x7F; //kropka zapalona
				 if(kropka==255) Segment = wys_2 | 0x80; //kropka zgaszona
	             break;
        case 3 : Display ^= 0<<Disp3|1<<Disp2|1<<Disp1|0<<Disp0;  
		         Segment  = wys_3; 
	             break;
        case 4 : Display ^= 0<<Disp3|0<<Disp2|1<<Disp1|1<<Disp0;  
		         Segment  = wys_4; 
	             break;
	 }	
	_delay_ms(1);
		
}



//Przerwanie z Timera 1
SIGNAL(SIG_OVERFLOW1)
{
  kropka = ~kropka;      // miga kropka Disp2

  /*************** Sterownie czasem ***********************/
  sec++;
  if(sec==60) 
  { 
  	min_l++; 
	sec=0;
  }
  //sterowanie minutami
  if(min_l==(9+1) && min_h==5) //xx:59
  {
  	godz_l++;
	min_h=0;
	min_l=0;
  }
  if(min_l==(9+1)) //xx:x9
  {
  	min_h++;
	min_l=0;
  }
  
  //sterowanie godzina
  if(godz_l==(3+1) && godz_h==2) //23:59
  {
  	godz_h=0;
	godz_l=0;
  }
  if(godz_l==(9+1)) //x9:xx
  {
  	godz_h++;
	godz_l=0;
  }
  
  /*************** zmiana czasu ***********************/
  if(bit_is_clear(Set_Bottom, Set_H)) //godziny
  {
   	if(bit_is_clear(Set_Bottom, Set_LV)) godz_l++;
  	if(bit_is_clear(Set_Bottom, Set_HV)) godz_h++;
	if(godz_l==(9+1)) godz_l=0;
	if(godz_h==(2+1)) godz_h=0;
  }

  if(bit_is_clear(Set_Bottom, Set_M)) //minuty 
  {
  	if(bit_is_clear(Set_Bottom, Set_LV)) min_l++;
  	if(bit_is_clear(Set_Bottom, Set_HV)) min_h++;
	if(min_l==(9+1)) min_l=0;
	if(min_h==(5+1)) min_h=0;
  }

  TCNT1 = 0xFC17;        // przeladowanie timer1 [max-1000]
}




int main(void)
{

//zmiana czasu
Set_Dir &= 0<<Set_H|0<<Set_M|0<<Set_LV|0<<Set_HV;
//segmenty wyswietlacza [dp .. a]
Seg_Dir = 0xFF;
Segment = 0xFF;
//numer wyswietlacza [Disp3 .. Disp0]
Disp_Dir |= 1<<Disp3|1<<Disp2|1<<Disp1|1<<Disp0;
Display  |= 1<<Disp3|1<<Disp2|1<<Disp1|0<<Disp0; 


//Timer1
TIMSK  = _BV(TOIE1);  // aktywacja przerwania T/C1
TCNT1  = 0xFC17;      // wartosc poczatkowa T/C1
TCCR1A = 0x00;        // aktywacja trybu czasomierza T/C1

TCCR1B = _BV(CS10)|_BV(CS12); // preskaler clk/1024 [1kHz]



sei(); //wlaczenie przerwan



while(1)
{
display_7seg(init,godz_h,godz_l,min_h,min_l);

init++;
if(init==5) init=1;
}



return 0;
}
