/*******************************************************************************/
/*					             PROPOX                                        */
/*                           www.propox.com                                    */
/*                                                                             */
/* Program demonsturjacy dzilanie przetwornika ADC - PF0 wejscie analogowe.    */
/* This program show how to use ADC converter - PF0 analog input.              */
/*******************************************************************************/
// wewnetrzny zegar 1MHz (internal oscillator 1MHz)
// PD0 - R/S
// PD1 - E
// PD2 - D4
// PD3 - D5
// PD4 - D6
// PD5 - D7
// ADC
// PF0 - POT1
#include <avr/io.h>
#include <avr/interrupt.h>        
#include <avr/signal.h>
#include <avr/sleep.h>  

#include "char_code.h"
#include "LCD_lib.h"


volatile uint8_t  value;
volatile uint8_t  value_bit[8];

const uint8_t tytul[] = ("www.propox.com");
const uint8_t wartosc[] = ("ADC val:");



//przerwanie z przetwornika ADC (ADC interrupt)
SIGNAL(SIG_ADC)                        
{
uint8_t i;

  	value = ADCH;
	//wartosc z przetwornika (value ADC)
  	for(i=0;i<8;i++){
	value_bit[i] = ((value & 0x80)>>7)|0x30;
	value = value << 1;
	}
	LCDGotoXY(8,1);
    LCDstring(value_bit,8);
	ADCSRA = _BV(ADEN)|_BV(ADIE)|_BV(ADSC)|_BV(ADPS1)|_BV(ADPS0);
  
} 



int main(void)
{
//LCD
LCDinit();
LCDcursorOFF();
LCDGotoXY(1,0);
LCDstring(tytul,14);
LCDGotoXY(0,1);
LCDstring(wartosc,8);

//Sleep mode
set_sleep_mode(SLEEP_MODE_ADC); 

//ADC
ADMUX  = _BV(REFS0)|_BV(ADLAR);
ADCSRA = _BV(ADEN)|_BV(ADIE)|_BV(ADSC)|_BV(ADPS1)|_BV(ADPS0);
//Przerwania wlaczone (interrupts on)
sei(); 
//Sleep
sleep_mode();

	while(1)
	{
	}
	
return 0;
}
