/*******************************************************************************/
/*					             PROPOX                                        */
/*                           www.propox.com                                    */
/*                                                                             */
/* Program demonsturjacy dzialanie pamieci flash AT45DB.                       */
/* This program show how to use AT45DB flash with atmega microcontroller.      */
/*******************************************************************************/
//ATMEGA128
// wewnetrzny zegar 1MHz (internal oscillator 1MHz)
// LCD
// PD0 - R/S
// PD1 - E
// PD2 - D4
// PD3 - D5
// PD4 - D6
// PD5 - D7
// Memory
// PB1 - SCK
// PB6 - SO
// PB2 - SI
// PB3 - CS
 
#include <avr/io.h>

#include "char_code.h"
#include "LCD_lib.h"
#include "dataflash.h"


uint8_t website[] = "www.propox.com";
uint8_t status_byte;

int main(void)
{
LCDinit();
LCDcursorOFF();
LCDGotoXY(1,0);
LCDstring(website,14);
LCDGotoXY(0,1);

DF_SPI_init();
status_byte = Read_DF_status();

switch((status_byte & 0x38) >> 3)
	{
	    case 0x00 : LCDstring("AT45DB001  500kb",16); break;
        case 0x01 : LCDstring("AT45DB011    1Mb",16); break;
        case 0x02 : LCDstring("AT45DB021    2Mb",16); break;
        case 0x03 : LCDstring("AT45DB041    4Mb",16); break;
        case 0x04 : LCDstring("AT45DB081    8Mb",16); break;
		case 0x05 : LCDstring("AT45DB161   16Mb",16); break;
		case 0x06 : LCDstring("AT45DB321   32Mb",16); break;
		case 0x07 : LCDstring("AT45DB642   64Mb",16); break;
		default   : LCDstring("AT45DB642   tttt",16); break;
	}

	while(1)
	{
	}
	
return 0;
}
